<?php

  // Include the configuration and database functions.
  require_once("../includes/config.php");

  // Bounce non-admin users out:
  if ( !in_array($unity_id, $admin_users) ) {
    header('Location: ../');
  }

  require_once("../includes/db_functions.php");

  // Connect to the database.
  $collectionsreview_connection = db_connect($db_host, $db_port, $db_user, $db_pass, $db_name);

//  if ( isset($_GET['show']) && ($_GET['show'] == "all_ranked_titles") ) {
//    $show_all_ranked_titles = "y";
//  }
//  else {
//    $show_all_ranked_titles = "";
//  }

  if ( isset($_GET['user_search']) && ($_GET['user_search'] != "") ) {
    $user_search = $_GET['user_search'];
  }
  elseif ( isset($_GET['user_search']) && ($_GET['user_search'] == "") ) {
    $user_search = "";
  }
  else {
    $user_search = "";
  }

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">

  <head>
    <title>Admin - Collections and Journals Review</title>
  	<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
    <link rel="stylesheet" href="../includes/css/style.css" type="text/css" />
  </head>

  <body>
  
    <h1>Collections and Journals Review</h1>
    <h2>Administration Tools</h2>

    <hr />

    <h3>Information about Titles:</h3>

    <p><a href="csv_all_ranked_titles.php">List of All Ranked Titles, User Info, Ranks, and Comments</a> (CSV file)</p>
    
    <p><a href="all_ranked_titles.php">Number of Titles Ranked or Commented On at Least Once</a></p>
  
    <hr />

    <h3>Information about Users:</h3>

    <form action=<?php print $_SERVER['PHP_SELF']; ?> method="get" >
      <input type="text" name="user_search" value="<?php print stripslashes($user_search); ?>" />
      <input type="submit" value="User Lookup" />&nbsp;&nbsp; (by Name or ID; use asterisk (*) to return all users)
    </form>
  
    <p>
      <form action="count_by_affiliation.php" method="get">
        Number of Logged-in Users by:
        <select name="type">
          <option value="ncsuaffiliation" selected="selected">NCSU Affiliation</option>
          <option value="departmentnumber">Department Number</option>
          <option value="ncsupreferreddepartment">NCSU Preferred Department</option>
          <option value="employeetype">Employee Type</option>
          <option value="employeetitle">Employee Title</option>
          <option value="ncsuprimaryrole">NCSU Primary Role</option>
        </select>
        <input type="submit" value="Get Counts &raquo;" />
      </form>
    </p>

    <p><a href="csv_all_users.php">List of All Users</a> (CSV file)</p>
  
    <p><a href="../">&laquo; Return to List</a></p>

    <hr />

    <br />

    <?php

/*  COMMENTING THIS OUT.  THE FULL DISPLAY OF ALL DATA IS TOO WIDE FOR THE PAGE.
      if ( $show_all_ranked_titles == "y") {

        $all_ranked_titles_result_set = select_all_ranked_titles();

        if ( mysql_num_rows($all_ranked_titles_result_set) == 0 ) {
          print "<p><strong>No ranked titles.</strong></p>\n";
        }
        else {
          print "<p>" . mysql_num_rows($all_ranked_titles_result_set) . " Title Rankings" .
                "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"csv_all_ranked_titles.php\">Download as CSV</a></p>";
          print "<table class=\"thinBorder\" border=\"1\">\n" .
                "  <tr>\n" .
                "    <th class=\"center\">Title Control</th>\n" .
                "    <th class=\"center\">ISSN</th>\n" .
                "    <th class=\"center\">Title</th>\n" .
                "    <th class=\"center\">Publisher</th>\n" .
                "    <th class=\"center\">Call Number</th>\n" .
                "    <th class=\"center\">Subject</th>\n" .
                "    <th class=\"center\">Unit Price</th>\n" .
                "    <th class=\"center\">2011 Electronic Usage Downloads</th>\n" .
                "    <th class=\"center\">2012 Electronic Usage Downloads</th>\n" .
                "    <th class=\"center\">2013 Electronic Usage Downloads</th>\n" .
                "    <th class=\"center\">2012 Impact Factor</th>\n" .
                "    <th class=\"center\">Number of publications by NCSU authors (most recent 5 years)</th>\n" .
                "    <th class=\"center\">Cited by NCSU authors (most recent 5 years)</th>\n" .
                "    <th class=\"center\">Name</th>\n" .
                "    <th class=\"center\">Email</th>\n" .
                "    <th class=\"center\">Unity ID</th>\n" .
                "    <th class=\"center\">Department Number</th>\n" .
                "    <th class=\"center\">NCSU Preferred Department</th>\n" .
                "    <th class=\"center\">NCSU Affiliation</th>\n" .
                "    <th class=\"center\">Employee Type</th>\n" .
                "    <th class=\"center\">Employee Title</th>\n" .
                "    <th class=\"center\">NCSU Primary Role</th>\n" .
                "    <th class=\"center\">Ranking</th>\n" .
                "    <th class=\"center\">Comments</th>\n" .
                "    <th class=\"center\">Display</th>\n" .
                "  </tr>";
          while ( $row = mysql_fetch_assoc($all_ranked_titles_result_set) ) {
            if ($row['name'] == "") {
              $row['name'] = $row['unity_id'];
            }
            print "  <tr class=\"trow\">\n" .
                  "    <td>" . htmlspecialchars($row['titlecontrol']) . "</td>\n" .
                  "    <td>" . htmlspecialchars($row['issn']) . "</td>\n" .
                  "    <td>" . htmlspecialchars($row['title']) . "</td>\n" .
                  "    <td>" . htmlspecialchars($row['publisher']) . "</td>\n" .
                  "    <td>" . htmlspecialchars($row['callnumber']) . "</td>\n" .
                  "    <td>" . htmlspecialchars($row['subject']) . "</td>\n" .
                  "    <td>" . htmlspecialchars($row['unitprice']) . "</td>\n" .
                  "    <td>" . htmlspecialchars($row['usage2011']) . "</td>\n" .
                  "    <td>" . htmlspecialchars($row['usage2012']) . "</td>\n" .
                  "    <td>" . htmlspecialchars($row['usage2013']) . "</td>\n" .
                  "    <td>" . htmlspecialchars($row['impact2012']) . "</td>\n" .
                  "    <td>" . htmlspecialchars($row['publicationsncsulast5years']) . "</td>\n" .
                  "    <td>" . htmlspecialchars($row['citationsncsulast5years']) . "</td>\n" .
                  "    <td><a href=\"mailto:" . htmlspecialchars($row['email']) . "\">" . htmlspecialchars($row['name']) . "</a></td>\n" .
                  "    <td>" . htmlspecialchars($row['email']) . "</td>\n" .
                  "    <td>" . htmlspecialchars($row['unity_id']) . "</td>\n" .
                  "    <td>" . htmlspecialchars($row['departmentnumber']) . "</td>\n" .
                  "    <td>" . htmlspecialchars($row['ncsupreferreddepartment']) . "</td>\n" .
                  "    <td>" . htmlspecialchars($row['ncsuaffiliation']) . "</td>\n" .
                  "    <td>" . htmlspecialchars($row['employeetype']) . "</td>\n" .
                  "    <td>" . htmlspecialchars($row['employeetitle']) . "</td>\n" .
                  "    <td>" . htmlspecialchars($row['ncsuprimaryrole']) . "</td>\n" .
                  "    <td>" . htmlspecialchars($row['rank']) . "</td>\n" .
                  "    <td>" . htmlspecialchars($row['comments']) . "</td>\n" .
                  "    <td>" . htmlspecialchars($row['display']) . "</td>\n" .
                  "  </tr>\n";
          }
        print "</table>\n";
        }
      }
*/

    ?>

    <?php

      if ( $user_search != "" ) {

        $matching_user_name_result_set = select_matching_user_name($user_search);

        if ( mysql_num_rows($matching_user_name_result_set) == 0 ) {
          print "<p><strong>No matching users.</strong></p>\n";
        }
        else {
          print "<p>" . mysql_num_rows($matching_user_name_result_set) . " Users" .
                "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"csv_all_users.php\">Download as CSV</a></p>";
          print "<p>Click a name to retrieve ranks/comments by that user.</p>";
          print "<table class=\"thinBorder\" border=\"1\">\n" .
                "  <tr>\n" .
                "    <th class=\"center\">Name</th>\n" .
                "    <th class=\"center\">Email</th>\n" .
                "    <th class=\"center\">NCSU Preferred Department</th>\n" .
                "    <th class=\"center\">NCSU Affiliation</th>\n" .
                "    <th class=\"center\">Employee Type</th>\n" .
                "    <th class=\"center\">Employee Title</th>\n" .
                "    <th class=\"center\">NCSU Primary Role</th>\n" .
                "</tr>";
  
          while ( $row = mysql_fetch_assoc($matching_user_name_result_set) ) {
            $user_id =  $row['user_id'];
            $name = $row['name'];
            $email = $row['email'];
            $unity_id = $row['unity_id'];
            $departmentnumber = $row['departmentnumber'];
            $ncsupreferreddepartment = $row['ncsupreferreddepartment'];
            $ncsuaffiliation = $row['ncsuaffiliation'];
            $employeetype = $row['employeetype'];
            $employeetitle = $row['employeetitle'];
            $ncsuprimaryrole = $row['ncsuprimaryrole'];
            print "  <tr class=\"trow\">\n" .
                  "    <td><a href=\"ranks_by_user.php?unity_id=" . $unity_id . "\" title=\"Get Rankings\">" . htmlspecialchars($name) . "</a></td>\n" .
                  "    <td>" . "<a href=\"mailto:" . htmlspecialchars($email) . "\">" . htmlspecialchars($email) . "</a></td>\n" .
                  "    <td>" . htmlspecialchars($ncsupreferreddepartment) . "</td>\n" .
                  "    <td>" . htmlspecialchars($ncsuaffiliation) . "</td>\n" .
                  "    <td>" . htmlspecialchars($employeetype) . "</td>\n" .
                  "    <td>" . htmlspecialchars($employeetitle) . "</td>\n" .
                  "    <td>" . htmlspecialchars($ncsuprimaryrole) . "</td>\n" .
                  "  </tr>\n";
          }
  
          print "</table>\n";
  
  
        }

      }

      // db_close($collectionsreview_connection);

    ?> 	

  </body>

</html>
