<?php

  if ( isset($_GET['column_name']) && ($_GET['column_name'] != "" ) ) {
    $column_name = $_GET['column_name'];
    switch ($column_name) {

      case "title" : $column_details = "<strong>Title</strong><br />Journal titles listed in the proposed cancellation list represent paid subscriptions.  Through consortial partners such as TRLN, the NCSU Libraries has license agreements with several publishers that allow us access to a broader selection of titles (a.k.a. non-subscribed titles) beyond our subscribed list. Only our subscribed titles appear on the serial review list.  Typically, after cancelling a subscribed title the Libraries will maintain electronic access to the subscribed years/backfiles of a title. However, if we cancel or decide to not renew a collection of journals, we may lose all access to the additional non-subscribed titles."; break;

      case "publisher" : $column_details = "<strong>Publisher</strong><br />The publishers listed are the most current known providers of the journals."; break;

      case "callnumber" : $column_details = "<strong>Call Number</strong><br />The call numbers listed follow the Library of Congress classification scheme and refers to specific elements such as subjects and author/publisher identifiers.<br /><br /><strong>NOTE:</strong>  Sorting by call number may not produce a perfect sequence because of the mixture of alphabetical characters and numbers.  Please look up and down the list to ensure you see all the titles for which you are searching."; break;

      case "subject" : $column_details = "<strong>Subject</strong><br />Each journal is assigned to a broad disciplinary group based on Library of Congress subject designations."; break;

      case "unitprice" : $column_details = "<strong>Unit Price</strong><br />Prices listed reflect the individual subscription cost for a journal and may not reflect the actual cost of a journal when it is part of a package.  High cost of a journal should be weighed against importance to the NCSU community and other factors."; break;

      case "usage" : $column_details = "<strong>Electronic Usage Downloads</strong><br />These counts represent the number of Full-Text Article Downloads, as reported by publishers according to COUNTER Codes of Practice. The electronic usage download data is provided for the years 2011, 2012, and 2013. Not all publishers provide electronic usage data, therefore, some titles will have a null value (indicated by \"--\"). It's also important to remember that print-only subscriptions will not have data for \"Downloads\" - the usage for print-only journal subscriptions will have a null value."; break;

      case "impact2012" : $column_details = "<strong>2012 Impact Factor</strong><br />From the Institute for Scientific Information’s (ISI) Journal Citation Reports database, the journal impact factor is the number of cites in a particular year (e.g., 2012) to articles published in the two preceding years (e.g., 2011 and 2010) divided by the number of published articles in that same time period (2011 and 2010).  If a journal is not indexed by ISI, there will be no journal impact factor (indicated by \"--\")."; break;

      case "citationsncsulast5years" : $column_details = "<strong>Cited by NCSU authors (most recent 5 years)</strong><br />This data shows the total number of citations to journals by NCSU authors summed over the past 5 years. If the Institute for Scientific Information (ISI) does not index a title, then there will not be a value in this field (indicated by \"--\"). This does not mean that the journal has not been cited, it simply means that this data is not available from ISI. This value could be a good indication of a journal's relevance to subject areas in which NCSU researchers are publishing. This data comes from Local Journal Utilization Report data that is developed by the Institute for Scientific Information (ISI)."; break;

      case "publicationsncsulast5years" : $column_details = "<strong>Publications by NCSU authors (most recent 5 years)</strong><br />This data shows the total number of articles written by NCSU authors summed over the past 5 years. If the Institute for Scientific Information (ISI) does not index a title, then there will not be a value in this field (indicated by \"--\"). This does not mean that no NCSU authors have published in a given journal, it simply means that this data is not available from ISI. This data can indicate relative importance of journals in terms of research and publishing activity. It comes from the Local Journal Utilization Report."; break;

    }

  }
  else {
    $column_details = "<strong>ERROR:</strong><br />You did not specify a valid column name.";
  }

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">

  <head>
	<title>Collections and Journals Review 2014 - Column Details: NCSU Libraries</title>
  	<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>

    <style>
      body {
        padding: 25px;
      }
    </style>

  </head>

  <body onload="window.focus();">
  
    <h1>Collections and Journals Review - Column Details</h1>

    <p><?php print $column_details; ?></p>
    
    <p>&nbsp;</p>
    
    <p><a href="#" onclick=window.close()><img src="images/x.gif" border="0" /></a> <a href="#" onclick=window.close()>Close</a></p>
  	
  </body>

</html>
