<?php

  // Set the MIME type header and file name.
  $download_file_name = "collectionsreview";
  header('Content-type: text/plain; charset=utf-8');
  header('Content-Disposition: attachment; filename="' . $download_file_name . '.csv"');

  // Include the configuration and database functions.
  require_once("./includes/config.php");
  require_once("./includes/db_functions.php");

  // Connect to the database.
  $collectionsreview_connection = db_connect($db_host, $db_port, $db_user, $db_pass, $db_name);

  // Build the query string.
  if ( isset($_SERVER['QUERY_STRING']) && ($_SERVER['QUERY_STRING'] != "") ) {
    $query_string = $_SERVER['QUERY_STRING'];
  }
  else {
    $query_string = "";
  }

  // Retrieve the list of titles requested.
  $title_result_set = select_titles($query_string, $pagesize, $unity_id);

  // Retrieve the database resource of titles which this user has ranked, if any.
  $title_rankings_by_user_result_set = title_rankings_by_user($unity_id);
  $ranked_title_ids = array();
  $commented_title_ids = array();
  while ( $title_rankings_by_user = mysql_fetch_assoc($title_rankings_by_user_result_set) ) {
    $ranked_title_ids[$title_rankings_by_user['title_id']] = $title_rankings_by_user['rank'];
    $commented_title_ids[$title_rankings_by_user['title_id']] = $title_rankings_by_user['comments'];
  }

  // Draw the header row.
  $header_row = "\"Title\"," .
                "\"Publisher\"," .
                "\"Call Number\"," .
                "\"Subject\"," .
                "\"Unit Price\"," .
                "\"2011 Electronic Usage Downloads\"," .
                "\"2012 Electronic Usage Downloads\"," .
                "\"2013 Electronic Usage Downloads\"," .
                "\"2012 Impact Factor\"," .
                "\"Number of publications by NCSU authors (most recent 5 years)\"," .
                "\"Cited by NCSU authors (most recent 5 years)\"," .
                "\"My Rank\"," .
                "\"My Comments\"\n";
  print $header_row;

  // Display the appropriate rows and columns.
  while ($row = mysql_fetch_assoc($title_result_set)) {

    $title_id = $row['title_id'];
    $title = str_replace("\"", "'", $row['title']);
    $publisher = str_replace("\"", "'", $row['publisher']);
    $callnumber = $row['callnumber'];
    $subject = $row['subject'];
    $unitprice = $row['unitprice'];
    $usage2011 = $row['usage2011'];
    if ($usage2011 == "") {
      $usage2011 = "--";
    }
    $usage2012 = $row['usage2012'];
    if ($usage2012 == "") {
      $usage2012 = "--";
    }
    $usage2013 = $row['usage2013'];
    if ($usage2013 == "") {
      $usage2013 = "--";
    }
    $impact2012 = $row['impact2012'];
    if ($impact2012 == "") {
      $impact2012 = "--";
    }
    $publicationsncsulast5years = $row['publicationsncsulast5years'];
    if ($publicationsncsulast5years == "") {
      $publicationsncsulast5years = "--";
    }
    $citationsncsulast5years = $row['citationsncsulast5years'];
    if ($citationsncsulast5years == "") {
      $citationsncsulast5years = "--";
    }

    $csv_output = "\"" . $title . "\"," .
                  "\"" . $publisher . "\"," .
                  "\"" . $callnumber . "\"," .
                  "\"" . $subject . "\"," .
                  "\"" . $unitprice . "\"," .
                  "\"" . $usage2011 . "\"," .
                  "\"" . $usage2012 . "\"," .
                  "\"" . $usage2013 . "\"," .
                  "\"" . $impact2012 . "\"," .
                  "\"" . $publicationsncsulast5years . "\"," .
                  "\"" . $citationsncsulast5years . "\",";

    $rank_assigned = "n";
    $comments_present = "n";

    foreach($ranked_title_ids as $this_title_id => $this_title_rank) {
      if ($this_title_id == $title_id) {
        $csv_output .= "\"" . $this_title_rank . "\",";
        $rank_assigned = "y";
      }
    }
    if ($rank_assigned != "y") {
      $csv_output .= "\"\",";
    }

    foreach($commented_title_ids as $this_title_id => $this_title_comments) {
      if ($this_title_id == $title_id) {
        $csv_output .= "\"" . $this_title_comments . "\"\n";
        $comments_present = "y";
      }
    }
    if ($comments_present != "y") {
      $csv_output .= "\"\"\n";
    }

    print $csv_output;

  }

  // db_close($collectionsreview_connection);

?>

