<?php

  // Include the configuration and database functions.
  require_once("./includes/config.php");
  require_once("./includes/db_functions.php");

  // Connect to the database.
  $collectionsreview_connection = db_connect($db_host, $db_port, $db_user, $db_pass, $db_name);
  if ( !$collectionsreview_connection ) {
    $number_of_titles = "ERROR";
  }

  // Retrieve the list of titles requested.
  $title_result_set = select_titles("", $pagesize, $unity_id);

  if ( $title_result_set ) {
    $number_of_titles = mysql_num_rows($title_result_set);
  }
  else {
    $number_of_titles =	"0";
  }

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">

  <head>
	<title>Collections and Journals Review</title>
  	<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
  </head>

  <body>
  
    <h1>How to Use the Collections and Journals Review Form</h1>
    
<h2>Feedback and Ranking of Titles - To be completed by <?php print $completion_date; ?></h2>

<p>The list of potential journal cancellations is presented for review and ranking as an <a href="./">online webform</a> or as a <a href="./csv.php">downloadable .csv (comma-separated) file</a>.  For additional details about the timeline and process, see the <a href="">Review Process</a> info and <a href="">Factors to Consider</a> to learn more about the data used to review journals.</p>

<p>The list contains <?php print $number_of_titles; ?> titles from all subject areas. You should only review and rank the titles of relevance to your disciplines and areas of interest; it is not necessary for you to rank every title in the list. Sorting features are included in the webform (and in the downloadable .csv file) to enable you to focus your review on your areas of interest.</p>

<p>We are using a three-tiered ranking system based on the importance to your research and teaching: <strong>1 - Top Priority</strong>; <strong>2 - Medium Priority</strong>; <strong>3 - Low Priority</strong>. Select the appropriate rank for each title in your areas of interest. There is no need to select a ranking for titles that are not relevant to your areas of interest.</p>

<p>To use the <a href="./">online webform</a> you will need to log in using your Unity ID and password. Your name and email address will be pre-populated. Be sure to click the "Update My Info" button if you change your info. You may add comments to any journal listed to add any other relevant information to your ranking decisions.</p>

<p>When you log in for the first time, you will see the full list of titles proposed for cancellation. You may sort by any of the fields using the green and red arrows. This is a long list, so sorting may take a few moments. You may also filter by subject to only display titles in specific areas. Due to the interdisciplinary nature of research, it is advised that you review related subject areas or search by journal title keywords.</p>

<p>At any point you may select a ranking from the pull-down options; those selections are automatically saved and added to your "My Rankings" list. If you change a ranking, it will be automatically updated in your "My Rankings" list. Once you are finished making your review and rankings, you can "Logout" and your selections will be saved. During the comment period you can come back and update your selections or add more rankings at any time. At the end of the comment period, these rankings will be sent to the NCSU Libraries Collection Management Department.</p>

<p>If you do not want to use the webform and you prefer to use the <a href="./csv.php">downloadable .csv (comma-separated) file</a>, you will need to insert your rankings manually ("1 - Top Priority"; "2 - Medium Priority"; "3 - Low Priority"). Once you have completed your rankings, please send the file/spreadsheet to <?php print $contact_name; ?> (<a href="mailto:<?php print $contact_email; ?>"><?php print $contact_email; ?></a>). Microsoft Excel will typically open .csv files automatically, but if you need additional help opening the file, please see this <a href="http://office.microsoft.com/en-us/excel-help/import-or-export-text-txt-or-csv-files-HP010099725.aspx">help guide from Microsoft</a>.

<p>At any time during the review process feel free to <a href="">contact the Libraries</a> with questions. Librarians will also be happy to visit departments to talk further about the process and answer your questions.</p>

    <p><a href="#" onclick="window.close()"><img src="images/x.gif" border="0"></a> <a href="#" onclick="window.close()">Close</a></p>  	

  </body>

</html>
