<?php

  // ==========================================================================
  // This file contains various functions used throughout the application and
  // is organized in to the following groups:

  //   Connection functions
  //   Title selection functions
  //   Rankings functions
  //   User functions
  //   Admin functions
  //   Email functions


  // ==========================================================================
  // Connection functions

  function db_connect($db_host, $db_port, $db_user, $db_pass, $db_name) {
    $collectionsreview_connection = @mysql_connect("$db_host:$db_port", $db_user, $db_pass);
    if ( $collectionsreview_connection && mysql_select_db($db_name) ) {
      return $collectionsreview_connection;
    }
    else {
      return false;
    }
  }

  //function db_close($collectionsreview_connection) {
  //  mysql_close($collectionsreview_connection);
  //}


  // ==========================================================================
  // Title selection functions

  // --------------------------------------------------------------------------
  function select_titles($query_string, $pagesize, $unity_id) {

    $query_string_array = parse_str($query_string);

    // The default display is to show only those titles marked for display.
    $where_clause = "WHERE display = 'y'";

    // If the user entered a title search string, limit the query to matching titles.
    if ( isset($title_name) && ($title_name != "") ) {
      $where_clause = "WHERE title LIKE '%$title_name%' AND display = 'y'";
    }

    // If the user filtered by subject, set the WHERE clause accordingly.
    if ( isset($subject) && ($subject != "") ) {
      $where_clause = "WHERE subject = '$subject' AND display = 'y'";
    }

    // If the user clicked the link to show "Full List", modify the WHERE clause accordingly.
    if ( isset($show) && ($show == "all") ) {
      $where_clause = "WHERE display = 'y'";
    }

    // If the user clicked the link to "My Rankings", modify the WHERE clause accordingly.
    if ( isset($show) && ($show == "mine") ) {
      $join_clause = " JOIN rankings ON serialslist.title_id = rankings.title_id ";
      $where_clause = "WHERE rankings.unity_id = '$unity_id' AND display = 'y'";
    }
    else {
       $join_clause = "";
    }

    // If the user clicked one of the "Sort ascending" or "Sort descending" image links, set
    // a parameter accordingly.
    if ( isset($sequence) && ($sequence == "asc") ) {
      $sort_sequence = " ASC";
    }
    elseif ( isset($sequence) && ($sequence == "desc") ) {
      $sort_sequence = " DESC";
    }
    else {
      $sort_sequence = "";
    }

    // The default sort order is by title.  If the user clicked a column header,
    // modify the sort order accordingly.
    if ( isset($sortorder) && ($sortorder != "") ) {
      switch ($sortorder) {
        case "1": $sortorder = "title$sort_sequence"; break;
        case "2": $sortorder = "publisher$sort_sequence"; break;
        case "3": $sortorder = "callnumber$sort_sequence"; break;
        case "4": $sortorder = "subject$sort_sequence"; break;
        case "5": $sortorder = "unitprice$sort_sequence"; break;
        case "6": $sortorder = "usage2011$sort_sequence"; break;
        case "7": $sortorder = "usage2012$sort_sequence"; break;
        case "8": $sortorder = "usage2013$sort_sequence"; break;
        case "9": $sortorder = "publicationsncsulast5years$sort_sequence"; break;
        case "10": $sortorder = "citationsncsulast5years$sort_sequence"; break;
        default: $sortorder = "title ASC"; break;
      }
    }
    else {
      $sortorder = "title ASC";
    }

    $title_result_set = @mysql_query("SELECT serialslist.title_id,
                                            titlecontrol,
                                            issn,
                                            title,
                                            publisher,
                                            callnumber,
                                            subject,
                                            unitprice,
                                            usage2011,
                                            usage2012,
                                            usage2013,
                                            impact2012,
                                            publicationsncsulast5years,
                                            citationsncsulast5years,
                                            display
                               FROM         serialslist " .
                               $join_clause .
                               $where_clause .
                              "ORDER BY     $sortorder");
    if ( $title_result_set ) {
      return $title_result_set;
    }
    else {
      return false;
    }

  }

  // --------------------------------------------------------------------------
  function select_single_title($title_id) {

    $title_result = @mysql_query("SELECT title_id,
                                         titlecontrol,
                                         issn,
                                         title,
                                         publisher,
                                         callnumber,
                                         subject,
                                         unitprice,
                                         usage2011,
                                         usage2012,
                                         usage2013,
                                         impact2012,
                                         publicationsncsulast5years,
                                         citationsncsulast5years,
                                         display
                                    FROM serialslist
                                   WHERE title_id = '$title_id'");

    if ( $title_result ) {
      return $title_result;
    }
    else {
      return false;
    }

  }


  // --------------------------------------------------------------------------
  function title_rankings_by_user($unity_id) {
    $title_rankings_by_user_result_set = @mysql_query("SELECT rank_id,
                                                             title_id,
                                                             unity_id,
                                                             rank,
                                                             comments
                                                      FROM   rankings
                                                      WHERE  unity_id = '$unity_id'");

    if ($title_rankings_by_user_result_set) {
      return $title_rankings_by_user_result_set;
    }
    else {
      return false;
    }
  }

  // --------------------------------------------------------------------------
  function select_distinct_subjects() {
    $subject_list_result_set = mysql_query("SELECT DISTINCT subject
                                              FROM serialslist
                                              ORDER BY subject");
    if ($subject_list_result_set) {
      return $subject_list_result_set;
    }
    else {
      return false;
    }
  }


  // ==========================================================================
  // Rankings/comments functions

  // --------------------------------------------------------------------------
  function select_matching_ranking($title_id, $unity_id) {
    $matching_ranking_result_set = mysql_query("SELECT rank_id, 
                                                       title_id,
                                                       unity_id,
                                                       rank,
                                                       comments
                                                FROM   rankings
                                                WHERE  title_id = '$title_id'
                                                AND    unity_id = '$unity_id'");
    if ($matching_ranking_result_set) {
      return $matching_ranking_result_set;
    }
    else {
      return false;
    }
  }

  // --------------------------------------------------------------------------
  function insert_ranking($title_id, $unity_id, $rank) {
    $ranking_insert_result = mysql_query("INSERT INTO rankings
                                                      (title_id,
                                                       unity_id,
                                                       rank)
                                          VALUES      ('$title_id',
                                                       '$unity_id',
                                                      '$rank')");
    if ($ranking_insert_result) {
      return $ranking_insert_result;
    }
    else {
      return false;
    }
  }

  // --------------------------------------------------------------------------
  function update_ranking($title_id, $unity_id, $rank) {
    $ranking_update_result = mysql_query("UPDATE rankings
                                          SET    rank='$rank'
                                          WHERE  title_id = $title_id
                                          AND    unity_id = '$unity_id'");
    if ($ranking_update_result) {
      return $ranking_update_result;
    }
    else {
      return false;
    }
  }

  // --------------------------------------------------------------------------
  function delete_ranking($title_id, $unity_id) {
    $ranking_delete_result = mysql_query("DELETE FROM rankings
                                          WHERE       title_id = $title_id
                                          AND         unity_id = '$unity_id'");
    if ($ranking_delete_result) {
      return $ranking_delete_result;
    }
    else {
      return false;
    }
  }

  // --------------------------------------------------------------------------
  function insert_title_comments($title_id, $unity_id, $titlecomments) {
    $title_comments_insert_result = mysql_query("INSERT INTO rankings
                                                             (title_id,
                                                              unity_id,
                                                              comments)
                                                VALUES       ('$title_id',
                                                              '$unity_id',
                                                              '$titlecomments')");
    if ($title_comments_insert_result) {
      return $title_comments_insert_result;
    }
    else {
      return false;
    }
  }

  // --------------------------------------------------------------------------
  function update_title_comments($title_id, $unity_id, $titlecomments) {
    $title_comments_update_result = mysql_query("UPDATE rankings
                                                 SET    comments='$titlecomments'
                                                 WHERE  title_id = $title_id
                                                 AND    unity_id = '$unity_id'");
    if ($title_comments_update_result) {
      return $title_comments_update_result;
    }
    else {
      return false;
    }
  }

  // ==========================================================================
  // User functions

  // --------------------------------------------------------------------------
  function select_matching_user($unity_id) {
    $matching_user_result_set = @mysql_query("SELECT user_id,
                                                    name,
                                                    email,
                                                    unity_id,
                                                    departmentnumber,
                                                    ncsupreferreddepartment,
                                                    ncsuaffiliation,
                                                    employeetype,
                                                    employeetitle,
                                                    ncsuprimaryrole
                                             FROM   users
                                             WHERE  unity_id = '$unity_id'");
    if ( $matching_user_result_set ) {
      return $matching_user_result_set;
    }
    else {
      return false;
    }

  }

  // --------------------------------------------------------------------------
  function insert_user($name, $email, $unity_id, $departmentnumber, $ncsupreferreddepartment, $ncsuaffiliation, $employeetype, $employeetitle, $ncsuprimaryrole) {
    $name = mysql_real_escape_string($name);
    $email = mysql_real_escape_string($email);
    $unity_id = mysql_real_escape_string($unity_id);
    $departmentnumber = mysql_real_escape_string($departmentnumber);
    $ncsupreferreddepartment = mysql_real_escape_string($ncsupreferreddepartment);
    $ncsuaffiliation = mysql_real_escape_string($ncsuaffiliation);
    $employeetype = mysql_real_escape_string($employeetype);
    $employeetitle = mysql_real_escape_string($employeetitle);
    $ncsuprimaryrole = mysql_real_escape_string($ncsuprimaryrole);
    $user_insert_result = mysql_query("INSERT INTO users
                                                   (name,
                                                    email,
                                                    unity_id,
                                                    departmentnumber,
                                                    ncsupreferreddepartment,
                                                    ncsuaffiliation,
                                                    employeetype,
                                                    employeetitle,
                                                    ncsuprimaryrole)
                                       VALUES      ('$name',
                                                    '$email',
                                                    '$unity_id',
                                                    '$departmentnumber',
                                                    '$ncsupreferreddepartment',
                                                    '$ncsuaffiliation',
                                                    '$employeetype',
                                                    '$employeetitle',
                                                    '$ncsuprimaryrole')");
    if ($user_insert_result) {
      return $user_insert_result;
    }
    else {
      return false;
    }
  }

  // --------------------------------------------------------------------------
  function update_user($name, $email, $unity_id, $departmentnumber, $ncsupreferreddepartment, $ncsuaffiliation, $employeetype, $employeetitle, $ncsuprimaryrole) {
    $user_update_result = mysql_query("UPDATE users
                                       SET    name='$name',
                                              email='$email',
                                              unity_id='$unity_id',
                                              departmentnumber='$departmentnumber',
                                              ncsupreferreddepartment='$ncsupreferreddepartment',
                                              ncsuaffiliation='$ncsuaffiliation',
                                              employeetype='$employeetype',
                                              employeetitle='$employeetitle',
                                              ncsuprimaryrole='$ncsuprimaryrole'
                                       WHERE  unity_id = '$unity_id'");
    if ($user_update_result) {
      return $user_update_result;
    }
    else {
      return false;
    }
  }


  // ==========================================================================
  // Admin functions
  // These are used on the admin pages.

  // --------------------------------------------------------------------------
  function select_matching_user_name($user_search) {
    if ( ($user_search == "*") ) {
      $where_clause = "";
    }
    else {
      $where_clause = "WHERE name LIKE '%$user_search%' OR unity_id LIKE '%$user_search%'";
    }
    $matching_user_name_result_set = mysql_query("SELECT user_id,
                                                         name,
                                                         email,
                                                         unity_id,
                                                         departmentnumber,
                                                         ncsupreferreddepartment,
                                                         ncsuaffiliation,
                                                         employeetype,
                                                         employeetitle,
                                                         ncsuprimaryrole
                                                FROM     users
                                                $where_clause
                                                ORDER BY unity_id");
    if ($matching_user_name_result_set) {
      return $matching_user_name_result_set;
    }
    else {
      return false;
    }
  }

  // --------------------------------------------------------------------------
  function select_all_ranked_titles() {

    $all_ranked_titles_result_set = mysql_query("SELECT   *
                                                 FROM     serialslist, rankings, users
                                                 WHERE    serialslist.title_id = rankings.title_id
                                                 AND      rankings.unity_id = users.unity_id
                                                 ORDER BY serialslist.title");
    if ($all_ranked_titles_result_set) {
      return $all_ranked_titles_result_set;
    }
    else {
      return false;
    }
  }

  // --------------------------------------------------------------------------
  function count_all_ranked_titles() {
//    $count_all_ranked_titles_result_set = mysql_query("SELECT rank,COUNT(*) as count
//                                                       FROM rankings
//                                                       GROUP BY rank
//                                                       ORDER BY rank DESC");
    $count_all_ranked_titles_result_set = mysql_query("SELECT DISTINCT title_id
                                                       FROM rankings
                                                       WHERE rank IS NOT NULL");
    if ($count_all_ranked_titles_result_set) {
      return $count_all_ranked_titles_result_set;                                                       
    }
    else {
      return false;
    }
  }

  // --------------------------------------------------------------------------
  function count_all_commented_titles() {
    $count_all_commented_titles_result_set = mysql_query("SELECT DISTINCT title_id
                                                       FROM rankings
                                                       WHERE comments IS NOT NULL");
    if ($count_all_commented_titles_result_set) {
      return $count_all_commented_titles_result_set;                                                       
    }
    else {
      return false;
    }
  }

  // --------------------------------------------------------------------------
  function get_rankings_by_user($unity_id) {
    $get_rankings_by_user_result_set = mysql_query("SELECT   *
                                                    FROM     serialslist, rankings
                                                    WHERE    serialslist.title_id = rankings.title_id
                                                    AND      rankings.unity_id = '$unity_id'
                                                    ORDER BY serialslist.title");

    if ($get_rankings_by_user_result_set) {
      return $get_rankings_by_user_result_set;
    }
    else {
      return false;
    }

  }

  // --------------------------------------------------------------------------
  function count_by_affiliation($affiliation_type) {
    $count_by_affiliation_result_set = mysql_query("SELECT $affiliation_type,COUNT(*) as count
                                                    FROM users
                                                    GROUP BY $affiliation_type
                                                    ORDER BY count DESC");
    if ($count_by_affiliation_result_set) {
      return $count_by_affiliation_result_set;
    }
    else {
      return false;
    }
  }

  // ==========================================================================
  // Mail functions

  // --------------------------------------------------------------------------
  function send_mail_to_user() {
    
  }

  // --------------------------------------------------------------------------
  function send_mail_to_admin() {
    
  }

?>