function focusNameBox () {
  if (document.userdata_form) {
    document.userdata_form.username.focus();
  }
}

$(document).ready(function(){

  // If "appEnabled" is true, then all input fields are enabled.
  // To put the application in read-only mode, change this to "false",
  // and also change $enableDatabaseChanges in includes/config.php to "false".
  var appEnabled=true;
  if (appEnabled) {
    $(":input").removeAttr("disabled").removeAttr("readonly");
  }

  // Handle the user form data.
  $("form#userdata_form").submit(function(){
    var user_form = $("form#userdata_form");
    $(user_form).find(".user_form_result").remove();
    $.ajax({
      type:"POST",
      async:false,
      url:"userdata.php",
      data:{
        "name":$("input#username").val(),
        "email":$("input#useremail").val(),
        "unity_id":$("input#userunity_id").val(),
        "departmentnumber":$("input#userdepartmentnumber").val(),
        "ncsupreferreddepartment":$("input#userncsupreferreddepartment").val(),
        "ncsuaffiliation":$("input#userncsuaffiliation").val(),
        "employeetype":$("input#useremployeetype").val(),
        "employeetitle":$("input#usertitle").val(),
        "ncsuprimaryrole":$("input#userncsuprimaryrole").val(),
      },
      success: function(data, textStatus){
        $(user_form).find("input[type=submit]").after("<div class=\"user_form_result\">"+data+"</div>");
      },
      error:  function(data, textStatus){
        $(user_form).find("input[type=submit]").after("<div class=\"user_form_result\">Error</div>");
        location.reload();
      }
    });
    return false;
  });

  $("a.saveLogout").click(function(){
    $("form#userdata_form").trigger('submit');
    return true;
  });

  // Handle rankings form data.
  $("form#rankings_form select").change(function(){
    $(this).siblings(".ranking_form_result").remove();
    var selected = this;
    $.ajax({
      type:"POST",
      url:"rankings.php",
      data:{
        "rank":$(this).val(),
        "title_id":$(this).siblings("input.title_id").val()
      },
      success: function(data, textStatus){
        $(selected).after("<div class=\"ranking_form_result\">"+data+"</div>");
        // Implemented the "blur()" method here to remove the focus from the
        // dropdown list.  This prevents spurious, accidental changes to the
        // selection when using the up/down arrow keys to scroll through the
        // whole page.
        $(selected).blur();
      },
      error: function(data, textStatus){
        $(selected).after("<div class=\"ranking_form_result\">Error</div>");
        location.reload();       
      }
    });
    return false;
  });

  // ---------------------------------------------------------------------
  // Handlebars code for handling adding of comments for each title
  // See http://handlebarsjs.com/

  // Pre-compile comments form
  var comments_template_source = $("#comments_template").html();
  var comments_template = Handlebars.compile(comments_template_source);

  // Handle comment link clicks
  $(".comment_link").click(function(){

    var title = $(this).data("journal-title");
    var title_id = $(this).data("journal-title-id");
    var comments = $(this).data("comment-text");
    var comments_data={ title:title,
                     title_id:title_id,
                     comments:comments,
                     appEnabled:appEnabled
                   };

    $.modal(comments_template(comments_data));

    return false;

  });
  
  // Handle form submission
  $(document.body).on("submit","form.titlecommentsform",function(e){

    var title_info={ title_id:$(this).find(".title_id").val(),
                     comments:$.trim($(this).find(".titlecomments").val())
                   };
    $.ajax({
      type:"POST",
      url:"title_comments.php",
      data:title_info
    }).success(function(){
      var commentlinktext;
      // Test for length of comment
      if (title_info.comments.length == 0) {
        commentlinktext = "Add Optional Comments";
      }
      else {
        commentlinktext = "Edit Comments";
      }
      // insert comment as attribute to comment link
      $("table.journaltable").find("a.comment_link[data-journal-title-id='" + title_info.title_id + "']").data("comment-text",title_info.comments).text(commentlinktext);
      // close modal window
      $.modal.close();
      
    }).error(function(){
        alert('There was an error submitting your comment.  Please try again.');
    });

    e.preventDefault();
    return false;
  });
    
  // ---------------------------------------------------------------------

});

// Pop-up window for details for each column.
function column_details(column_name) {
  var w=window.open('column_details.php?column_name='+column_name,'column_details','height=600,width=600','location=0,menubar=0,resizable=1,scrollbars=1,status=0,toolbar=0');
  w.focus();
}

// Pop-up window for comments on each title.
function title_comments(title_id) {
  var w=window.open('title_comments.php?title_id='+title_id,'title_comments','height=750,width=800','location=0,menubar=0,resizable=1,scrollbars=1,status=0,toolbar=0');
  w.focus();
}
