<?php

  // Include the configuration and database functions.
  require_once("./includes/config.php");
  require_once("./includes/db_functions.php");

  // Connect to the database.
  $collectionsreview_connection = db_connect($db_host, $db_port, $db_user, $db_pass, $db_name);
  if ( !$collectionsreview_connection ) {
    print $database_connection_error;
    exit;
  }

  // Build the query string.
  if ( isset($_SERVER['QUERY_STRING']) && ($_SERVER['QUERY_STRING'] != "") ) {
    $query_string = $_SERVER['QUERY_STRING'];
  }
  else {
    $query_string = "";
  }

  // Retrieve the list of titles requested.
  $title_result_set = select_titles($query_string, $pagesize, $unity_id);

  if ( $title_result_set ) {

    $number_of_titles = mysql_num_rows($title_result_set);
  
    // Retrieve the database resource of titles which this user has ranked or commented on, if any.
    $title_rankings_by_user_result_set = title_rankings_by_user($unity_id);
    $ranked_title_ids = array();
    while ( $title_rankings_by_user = mysql_fetch_assoc($title_rankings_by_user_result_set) ) {
      $ranked_title_ids[$title_rankings_by_user['title_id']] = array();
      $ranked_title_ids[$title_rankings_by_user['title_id']]['rank'] = $title_rankings_by_user['rank'];
      $ranked_title_ids[$title_rankings_by_user['title_id']]['comments'] = $title_rankings_by_user['comments'];
    }

  }

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">

  <head>
	<title>Collections and Journals Review</title>
  	<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>

    <script src="./includes/js/jquery-1.7.2.min.js" type="text/javascript" charset="utf-8"></script>
    <script src="./includes/js/jquery.simplemodal.js" type="text/javascript" charset="utf-8"></script>
    <script src="./includes/js/collectionsreview.js" type="text/javascript" charset="utf-8"></script>
    <script src="./includes/js/handlebars-v1.1.2.js" type="text/javascript" charset="utf-8"></script>
    <link rel="stylesheet" href="./includes/css/style.css" type="text/css" />
    <link rel="stylesheet" href="./includes/css/simplemodal.basic.css" type="text/css" />

    <script id="comments_template" type="text/x-handlebars-template">
      <h1>{{title}}</h1>
      <p>Comments:</p>
      <form name="titlecommentsform" class="titlecommentsform" action="" method="post">
        <input type="hidden" class="title_id" name="title_id" value="{{title_id}}" />
        {{#if appEnabled}}
          <textarea name="titlecomments" class="titlecomments" cols="70" rows="8">{{comments}}</textarea>
          <br />
          <input type="submit" value="Submit" />
        {{else}}
          <textarea readonly="readonly" name="titlecomments" class="titlecomments" cols="70" rows="8">{{comments}}</textarea>
        {{/if}}
      </form>
    </script>

  </head>

  <body>
  
    <noscript>
      <table align="center" style="width: 742px;">
        <tr>
          <td bgcolor="#ffffff" style="border: 4px solid #cc0000; text-align: center; padding: 5px;">
            <h1><span style="color: #cc0000;"><strong>ATTENTION:</strong></span></h1>
            <p>You do not seem to have JavaScript enabled.<br />You will not be able to update your personal information or rank any titles.</p>
          </td>
        </tr>
      </table>
    </noscript>

    <h1>Collections and Journals Review</h1>

    <?php
      
      $matching_user_result_set = select_matching_user($unity_id);

      if ( !$matching_user_result_set ) {
        print $select_matching_user_error;
      }

      else {

        // If there is no matching record, set several variables to be empty, construct
        // a default email, and store the login ID and email in the "users" table.
        if ( mysql_num_rows($matching_user_result_set) == 0 ) {
          // Fetch user data from LDAP server
          $ds = @ldap_connect("ldap.example.com");
          if (!$ds) {
          	die("Unable to connect to LDAP.");
          }
          $res = @ldap_bind($ds);			# Anonymous bind
          $srch = @ldap_search($ds,
          	"ou=people,dc=example,dc=com",	# Search in people tree (directory info)
          	"uid=" . $unity_id,			# Search on login ID
          	array('cn',
          	      'mail',
          	      'uid',
          	      'departmentnumber',
          	      'ou',
          	      'ncsuaffiliation',
          	      'employeetype',
          	      'title',
          	      'ncsuprimaryrole'),
           0,   # We want values and types (see docs)
           1   # We want, at most, 1 result
          );
          if ($srch) {
          	$results = @ldap_get_entries($ds, $srch);
          	$name = $results[0]["cn"][0];
          	$email = $results[0]["mail"][0];
          	// Commenting out the following row.  Some users have no data in campus LDAP, and resetting
          	// $unity_id to whatever is in LDAP results in a null value, giving completely blank rows
          	// in the "users" table.
          	// $unity_id = $results[0]["uid"][0];
          	$departmentnumber = $results[0]["departmentnumber"][0];
          	$ncsupreferreddepartment = $results[0]["ou"][0];
          	$ncsuaffiliation = $results[0]["ncsuaffiliation"][0];
          	$employeetype = $results[0]["employeetype"][0];
          	$employeetitle = $results[0]["title"][0];
          	$ncsuprimaryrole = $results[0]["ncsuprimaryrole"][0];
          }
          else {
          	print "<strong>Directory lookup failed: " . ldap_error($ds) . "</strong><br />\n";
          }
          $user_insert_result = insert_user($name, $email, $unity_id, $departmentnumber, $ncsupreferreddepartment, $ncsuaffiliation, $employeetype, $employeetitle, $ncsuprimaryrole);
          $welcome_message = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Welcome, " . $name . "!";
        }
  
        // Otherwise, populate the form variables with the data.
        else {
          while ( $row = mysql_fetch_assoc($matching_user_result_set) ) {
            $name = $row['name'];
            $email = $row['email'];
            $unity_id = $row['unity_id'];
            $departmentnumber = $row['departmentnumber'];
            $ncsupreferreddepartment = $row['ncsupreferreddepartment'];
            $ncsuaffiliation = $row['ncsuaffiliation'];
            $employeetype = $row['employeetype'];
            $employeetitle = $row['employeetitle'];
            $ncsuprimaryrole = $row['ncsuprimaryrole'];
            if ($name == "") {
              $welcome_message = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Welcome, " . $unity_id . "!";
            }
            else {
              $welcome_message = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Welcome, " . $name . "!";
            }
          }
        }

      }

    ?>

    <?php
      // If the user query succeeded, draw the user data form.
      if ( $matching_user_result_set ) {
    ?>

    <table class="thinBorder" width="100%">
      <tr>
        <td width="33%">
          <p><strong><?php print $welcome_message; ?></strong></p>
        </td>
        <td width="33%" align="center">
          <p><a href="howtouse.php" target="_blank" title="Opens in new window">How to Use This Review Tool</a></p>
        </td>
        <td width="33%" align="center">
          <p><a href="" target="_blank" title="Opens in new window">Collections Review Home Page</a></p>
        </td>
      </tr>
    </table>

    <br />

    <form action="userdata.php" id="userdata_form" name="userdata_form" method="get">

      <input type="hidden" name="unity_id" id="userunity_id" value="<?php print htmlspecialchars($unity_id); ?>" />
      <input type="hidden" name="departmentnumber" id="userdepartmentnumber" value="<?php print htmlspecialchars($departmentnumber); ?>" />
      <input type="hidden" name="ncsupreferreddepartment" id="userncsupreferreddepartment" value="<?php print htmlspecialchars($ncsupreferreddepartment); ?>" />
      <input type="hidden" name="ncsuaffiliation" id="userncsuaffiliation" value="<?php print htmlspecialchars($ncsuaffiliation); ?>" />
      <input type="hidden" name="employeetype" id="useremployeetype" value="<?php print htmlspecialchars($employeetype); ?>" />
      <input type="hidden" name="employeetitle" id="usertitle" value="<?php print htmlspecialchars($employeetitle); ?>" />
      <input type="hidden" name="ncsuprimaryrole" id="userncsuprimaryrole" value="<?php print htmlspecialchars($ncsuprimaryrole); ?>" />

      <table class="user_information" border="0" width="100%">
        <tr>
          <td width="33%">
            <table border="0">
              <tr>
                <td align="right">Name:</td>
                <td align="left"><input readonly="readonly" type="text" size="30" name="name" id="username" value="<?php print htmlspecialchars($name); ?>" /></td>
              </tr>
              <tr>
                <td align="right">Email:</td>
                <td align="left"><input readonly="readonly" type="text" name="email" id="useremail" size="30" value="<?php print htmlspecialchars($email); ?>" /></td>
              </tr>
              <tr>
              <tr>
                <td>&nbsp;</td>
                <td align="left"><input disabled="disabled" type="submit" value="Update My Info" /></td>
              </tr>
            </table>
          </td>
          <td width="33%" align="center">
            <?php print $site_notification; ?>
            For additional questions or help,<br />please contact <a href="mailto:<?php print $contact_email; ?>"><?php print $contact_name; ?></a>.
          </td>
	        <td width="33%" align="right" valign="top">
	          <p><strong><a href="logout.php">Log Out</a></strong></p>
	          <?php
	            if ($enableDatabaseChanges == true) {
                print "<p>All your settings are automatically<br />stored for when you return.</p>\n";
	            }
	            else {
                print "<p>All your settings have been stored<br />and can no longer be changed.<br /><a href=\"?show=mine\">Show Your Rankings</a></p>\n";
	            }
	          ?>
            <?php
              // Display a link to "Admin Tools" if the logged-in user is
              // in the list of admin users (see includes/config.php).
              if ( in_array($unity_id, $admin_users) ) {
                print "<p><a href=\"admin/\">Admin Tools</a></p>";
              }
            ?>
	        </td>
        </tr>
      </table>

    </form>

    <?php
      // Close the "If the user query succeeded..." condition.
      // If that failed, then don't draw the user data form or the .
      }
    ?>

    <?php
      // If the title query succeeded, then print the table to "Customize your list."
      if ( $title_result_set ) {
    ?>

    <p><strong>Customize your list of titles:</strong></p>

    <table class="thinBorder" border="1" width="100%" bgcolor="#eeeeee">

	    <tr align="center">

        <td width="40%">
          <form action="<?php print $_SERVER['PHP_SELF']; ?>" name="filter_by_subject_form" method="get">
            <select name="subject">
              <option value="">-- Filter Full List by Subject --</option>
              <?php
                // Build the subject drop-down list.
                $subject_list_result_set = select_distinct_subjects();
                if ( isset($_GET['subject']) && ($_GET['subject'] != "") ) {
                  $subject_from_get = $_GET['subject'];
                }
                else {
                  $subject_from_get = "";
                }
                while ( $row = mysql_fetch_assoc($subject_list_result_set) ) {
                  if ($row['subject'] == $subject_from_get) {
                    $subject_selected = " selected=\"selected\"";
                  }
                  else {
                    $subject_selected = "";
                  }
                  if ($row['subject'] != "") {
                    print "          <option value=\"" . htmlspecialchars($row['subject']) . "\"" . $subject_selected . ">" . htmlspecialchars($row['subject']) . "</option>\n";
                  }
                }
              ?>
            </select>
            <input type="submit" value="Filter" />
          </form>
        </td>

      	<td width="35%">
          <form action="<?php print $_SERVER['PHP_SELF']; ?>" name="search_form" method="get">
            <?php     
              if ( isset($_GET['title_name']) && ($_GET['title_name'] != "") ) {
                $title_name = $_GET['title_name'];
              }
              else {
                $title_name = "";
              }
            ?>
            <input type="text" size="20" name="title_name" value="<?php print htmlspecialchars(stripslashes($title_name)); ?>" />
            <input type="submit" value="Search by Title" />
          </form>
        </td>

	    	<td width="25%">
          <p>
            <a href="?">Full List</a>
            <?php
              if ( $matching_user_result_set ) {
                print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"?show=mine\">My Rankings</a>\n";
              }
            ?>
          </p>
        </td>

      </tr>

    </table>

    <br />

    <?php
      // Close the "If the title query succeeded, then print the table to "Customize your list."" condition.
      }
    ?>

    <?php

      $additional_query_parameters = "";
      if ( isset($_GET['show']) && ($_GET['show'] == "all") ) {
        $additional_query_parameters .= "&show=all";
      }
      if ( isset($_GET['show']) && ($_GET['show'] == "mine") ) {
        $additional_query_parameters .= "&show=mine";
      }
      if ( isset($_GET['title_name']) && ($_GET['title_name'] != "") ) {
        $additional_query_parameters .= "&title_name=" . urlencode($_GET['title_name']);
      }
      if ( isset($_GET['publisher']) && ($_GET['publisher'] != "") ) {
        $additional_query_parameters .= "&publisher=" . urlencode($_GET['publisher']);
      }
      if ( isset($_GET['subject']) && ($_GET['subject'] != "subject") ) {
        $additional_query_parameters .= "&subject=" . urlencode($_GET['subject']);
      }

    ?>


    <?php
      // If no titles could be selected from the database, print a message accordingly.
      if ( !$title_result_set ) {
        print "<p><strong>$select_titles_error</strong></p>";
      }
      // If no titles were found, print a message accordingly.
      elseif ($number_of_titles == 0) {
        print "<p><strong>No titles found.</strong></p>";
      }
      // If titles were found...
      else {
      // Closing } down below...
    ?>

    <!-- <p align="center"><strong>Please rank only the titles of relevance to your areas of interest; it is not necessary to rank every title in the list.</strong></p> -->

    <table width="100%">
      <tr>
      	<td align="left">
            <?php
              if ($number_of_titles == 1) {
                print "<strong>" . $number_of_titles . " Title</strong>";
              }
              else {
                print "<strong>" . $number_of_titles . " Titles</strong>";
              }
            ?>
      	</td>
      	<td align="center">
      	  If data for downloads, citations, and publications is not available, the value of null is indicated by dashes ("--").
          <br /><br />
      	  <a href="csv.php?<?php print $query_string; ?>" target="_blank">Download this list as a Comma-Separated Variable (CSV) file</a> (for import into Excel or other spreadsheet software)
      	</td>
      </tr>
    </table>

    <form action="rankings.php" id="rankings_form" name="rankings_form" method="get">

      <table class="thinBorder journaltable" border="1">
  
        <tr>

          <th class="center"><a href="#" onclick=column_details('title') title="Details">Title</a></th>
          <th class="center"><a href="#" onclick=column_details('publisher') title="Details">Publisher</a></th>
          <th class="center"><a href="#" onclick=column_details('callnumber') title="Details">Call Number</a></th>
          <th class="center"><a href="#" onclick=column_details('subject') title="Details">Subject</a></th>
          <th class="center"><a href="#" onclick=column_details('unitprice') title="Details">Unit Price</a></th>
          <th class="center" colspan="3"><a href="#" onclick=column_details('usage') title="Details">Downloads</a></th>
          <th class="center"><a href="#" onclick=column_details('publicationsncsulast5years') title="Details">Publications by NCSU Authors</a></th>
          <th class="center"><a href="#" onclick=column_details('citationsncsulast5years') title="Details">Cited by NCSU Authors</a></th>
          <th class="center">Importance to Your Research and Teaching</th>
        </tr>

        <tr>
          <th class="center"><br /><a href="?sortorder=1&sequence=asc<?php print $additional_query_parameters; ?>"><img src="images/ascending.gif" alt="Sort ascending (default)" title="Sort ascending" border="0" class="bottom" /></a><br /><a href="?sortorder=1&sequence=desc<?php print $additional_query_parameters; ?>"><img src="images/descending.gif" alt="Sort descending" title="Sort descending" border="0" class="bottom" /></a></th>
          <th class="center"><br /><a href="?sortorder=2&sequence=asc<?php print $additional_query_parameters; ?>"><img src="images/ascending.gif" alt="Sort ascending" title="Sort ascending" border="0" class="bottom" /></a><br /><a href="?sortorder=2&sequence=desc<?php print $additional_query_parameters; ?>"><img src="images/descending.gif" alt="Sort descending" title="Sort descending" border="0" class="bottom" /></a></th>
          <th class="center"><br /><a href="?sortorder=3&sequence=asc<?php print $additional_query_parameters; ?>"><img src="images/ascending.gif" alt="Sort ascending" title="Sort ascending" border="0" class="bottom" /></a><a href="?sortorder=3&sequence=desc<?php print $additional_query_parameters; ?>"><br /><img src="images/descending.gif" alt="Sort descending" title="Sort descending" border="0" class="bottom" /></a></th>
          <th class="center"><br /><a href="?sortorder=4&sequence=asc<?php print $additional_query_parameters; ?>"><img src="images/ascending.gif" alt="Sort ascending" title="Sort ascending" border="0" class="bottom" /></a><a href="?sortorder=4&sequence=desc<?php print $additional_query_parameters; ?>"><br /><img src="images/descending.gif" alt="Sort descending" title="Sort descending" border="0" class="bottom" /></a></th>
          <th class="center"><br /><a href="?sortorder=5&sequence=asc<?php print $additional_query_parameters; ?>"><img src="images/ascending.gif" alt="Sort ascending" title="Sort ascending" border="0" class="bottom" /></a><a href="?sortorder=5&sequence=desc<?php print $additional_query_parameters; ?>"><br /><img src="images/descending.gif" alt="Sort descending" title="Sort descending" border="0" class="bottom" /></a></th>
          <th class="center">2011<br /><a href="?sortorder=6&sequence=asc<?php print $additional_query_parameters; ?>"><img src="images/ascending.gif" alt="Sort ascending" title="Sort ascending" border="0" class="bottom" /></a><a href="?sortorder=6&sequence=desc<?php print $additional_query_parameters; ?>"><br /><img src="images/descending.gif" alt="Sort descending" title="Sort descending" border="0" class="bottom" /></a></th>
          <th class="center">2012<br /><a href="?sortorder=7&sequence=asc<?php print $additional_query_parameters; ?>"><img src="images/ascending.gif" alt="Sort ascending" title="Sort ascending" border="0" class="bottom" /></a><a href="?sortorder=7&sequence=desc<?php print $additional_query_parameters; ?>" border="0"><br /><img src="images/descending.gif" alt="Sort descending" title="Sort descending" border="0" class="bottom" /></a></th>
          <th class="center">2013<br /><a href="?sortorder=8&sequence=asc<?php print $additional_query_parameters; ?>"><img src="images/ascending.gif" alt="Sort ascending" title="Sort ascending" border="0" class="bottom" /></a><a href="?sortorder=8&sequence=desc<?php print $additional_query_parameters; ?>" border="0"><br /><img src="images/descending.gif" alt="Sort descending" title="Sort descending" border="0" class="bottom" /></a></th>
          <th class="center"><br /><a href="?sortorder=9&sequence=asc<?php print $additional_query_parameters; ?>"><img src="images/ascending.gif" alt="Sort ascending" title="Sort ascending" border="0" class="bottom" /></a><a href="?sortorder=9&sequence=desc<?php print $additional_query_parameters; ?>"><br /><img src="images/descending.gif" alt="Sort descending" title="Sort descending" border="0" class="bottom" /></a></th>
          <th class="center"><br /><a href="?sortorder=10&sequence=asc<?php print $additional_query_parameters; ?>"><img src="images/ascending.gif" alt="Sort ascending" title="Sort ascending" border="0" class="bottom" /></a><a href="?sortorder=10&sequence=desc<?php print $additional_query_parameters; ?>"><br /><img src="images/descending.gif" alt="Sort descending" title="Sort descending" border="0" class="bottom" /></a></th>
          <th class="center">Rank<br />(Saved on change)</th>
        </tr>
  
        <?php
  
          // Display the appropriate rows and columns.
          while ($row = mysql_fetch_assoc($title_result_set)) {
            $title_id = htmlspecialchars($row['title_id']);
            $title = htmlspecialchars($row['title']);
            $publisher = htmlspecialchars($row['publisher']);
            $callnumber = htmlspecialchars($row['callnumber']);
            $subject = htmlspecialchars($row['subject']);
            $unitprice = htmlspecialchars($row['unitprice']);
            $usage2011 = htmlspecialchars($row['usage2011']);
            if ($usage2011 == "") {
              $usage2011 = "--";
            }
            $usage2012 = htmlspecialchars($row['usage2012']);
            if ($usage2012 == "") {
              $usage2012 = "--";
            }
            $usage2013 = htmlspecialchars($row['usage2013']);
            if ($usage2013 == "") {
              $usage2013 = "--";
            }
            $publicationsncsulast5years = htmlspecialchars($row['publicationsncsulast5years']);
            if ($publicationsncsulast5years == "") {
              $publicationsncsulast5years = "--";
            }
            $citationsncsulast5years = htmlspecialchars($row['citationsncsulast5years']);
            if ($citationsncsulast5years == "") {
              $citationsncsulast5years = "--";
            }

            print "<tr class=\"trow\">\n" .
                  "  <td title=\"Title\">" . $title . "</td>\n" .
                  "  <td title=\"Publisher\">" . $publisher . "</td>\n" .
                  "  <td title=\"Call Number\">" . str_replace(" ", "<br />", $callnumber) . "</td>\n" .
                  "  <td title=\"Subject\">" . $subject . "</td>\n" .
                  "  <td title=\"Unit Price\" align=\"right\">$" . number_format($unitprice, 2, '.', ',') . "</td>\n" .
                  "  <td title=\"2011 Electronic Usage Downloads\" align=\"center\">" . $usage2011 . "</td>\n" .
                  "  <td title=\"2012 Electronic Usage Downloads\" align=\"center\">" . $usage2012 . "</td>\n" .
                  "  <td title=\"2013 Electronic Usage Downloads\" align=\"center\">" . $usage2013 . "</td>\n" .
                  "  <td title=\"Number of publications by NCSU authors (most recent 5 years)\" align=\"center\">" . $publicationsncsulast5years . "</td>\n" .
                  "  <td title=\"Cited by NCSU authors (most recent 5 years)\" align=\"center\">" . $citationsncsulast5years . "</td>\n" .
                  "  <td title=\"Select a ranking\">\n" .
                  "    <input type=\"hidden\" name=\"title_id\" class=\"title_id\" value=\"" . $title_id . "\" />\n" .
                  "    <select disabled=\"disabled\" name=\"rank\" class=\"rank\">\n";
            print "      <option value=\"\">None</option>\n";

            foreach($rankings as $this_rank) {
              // Note:  $rankings is an array set in includes/config.php.
              // Set the default selection to empty.
              $rank_selected = "";
              // If a user ranking exists for this title...
              if (isset($ranked_title_ids[$title_id])) {
                // If the user rank matches the rank we are currently printing...
                if ($ranked_title_ids[$title_id]['rank'] == $this_rank) {
                  // Make it selected
                  $rank_selected = " selected=\"selected\"";
                }
              }
              print "      <option value=\"" . htmlspecialchars($this_rank) . "\"" . $rank_selected . ">" . htmlspecialchars($this_rank) . "</option>\n";
            }

            print "    </select>\n";

            // If a comment already exists in the database for this title, store the text in $comment_text
            // for use in the attribute "data-comment-text".  Also set the displayed link accordingly.
            if ( isset($ranked_title_ids[$title_id]['comments']) && ($ranked_title_ids[$title_id]['comments'] != "") ) {
              $comment_text = htmlspecialchars($ranked_title_ids[$title_id]['comments']);
              $comment_link_text = "Edit Comments";
            }
            // If no comment already exists in the database, then set $comment_text to empty and set the
            // displayed link to the default.
            else {
              $comment_text = "";
              $comment_link_text = "Add Optional Comments";
            }
            print "    <br /><a href=\"#\" class=\"comment_link\" data-comment-text=\"" . $comment_text . "\" data-journal-title=\"" . $title . "\" data-journal-title-id=\"" . $title_id . "\">" . $comment_link_text . "</a>\n";

            print "  </td>\n" .
                  "</tr>\n";


          }
  
        ?>
  
      </table>
      
      <?php
        // Close the "If titles were found..." condition.
        }
      ?>

    </form>

    <p align="right">All your settings are automatically stored for when you return.</p> 
 	
  </body>

</html>
