<?php

  // Include the configuration and database functions.
  require_once("./includes/config.php");

  // If we wish to "freeze" the database to further changes, we set this value
  // in includes/config.php to "false".  If that is the case, then we simply 
  // make this file "return" without processing any input.
  if ($enableDatabaseChanges == false) {
    return;
  }

  require_once("./includes/db_functions.php");

  // Connect to the database.
  $collectionsreview_connection = db_connect($db_host, $db_port, $db_user, $db_pass, $db_name);

  // -------------------------------------------------------------------
  // Receive/store data from index.php via $_GET array
  
  if ( (isset($_POST['title_id'])) && ($_POST['title_id'] != "") ) {
    $title_id = $_POST['title_id'];
  }
  else {
    $title_id = "";
  }

  if ( (isset($_POST['rank'])) && ($_POST['rank'] != "") ) {
    $rank = htmlspecialchars($_POST['rank']);
  }
  else {
    $rank = "";
  }

  if ( (isset($_POST['comments'])) && ($_POST['comments'] != "") ) {
    $comments = htmlspecialchars($_POST['comments']);
  }
  else {
    $comments = "";
  }

  // -------------------------------------------------------------------
  // Check to see if there's a matching record for this combination of title_id
  // and unity_id in the "rankings" table.

  $matching_ranking_result_set = select_matching_ranking($title_id, $unity_id);

  // If there is no matching record for this title_id and unity_id...
  if ( mysql_num_rows($matching_ranking_result_set) == 0 ) {

    if ($rank != "") {
      insert_ranking($title_id, $unity_id, $rank);
      print "<img src=\"images/check.gif\" /> Added";
    }
    else {
      print "<img src=\"images/x.gif\" /> Missing title_id and/or rank. Database unchanged.";
    }

  }

  // Else if there is a matching record...
  elseif ( mysql_num_rows($matching_ranking_result_set) == 1 ) {
    $row = mysql_fetch_assoc($matching_ranking_result_set);
    $this_comment = $row['comments'];
    // If the new rank is empty, and there is no existing comment, delete the record.
    if ( ($rank == "") && ($this_comment == "") ) {
      delete_ranking($title_id, $unity_id);
      print "<img src=\"images/x.gif\" /> Removed";
    }
    // Otherwise, update the record.
    else {
      update_ranking($title_id, $unity_id, $rank);
      if ($rank == "") {
        print "<img src=\"images/x.gif\" /> Removed";
      }
      else {
        print "<img src=\"images/check.gif\" /> Updated";
      }
    }

  // Close the "Else if there is a matching record..." condition.
  }

  // db_close($collectionsreview_connection);

?>
