<?php

  // Include the configuration and database functions.
  require_once("./includes/config.php");

  // If we wish to "freeze" the database to further changes, we set this value
  // in includes/config.php to "false".  If that is the case, then we simply 
  // make this file "return" without processing any input.
  if ($enableDatabaseChanges == false) {
    return;
  }

  require_once("./includes/db_functions.php");

  // Connect to the database.
  $collectionsreview_connection = db_connect($db_host, $db_port, $db_user, $db_pass, $db_name);

  // -------------------------------------------------------------------
  // Receive/store data from index.php via $_POST array

  $error_message = "<img src=\"images/x.gif\" /> " . $userdata_storage_error;

  if ( isset($_POST['name']) ) {
    $name = trim($_POST['name']);
  }
  else {
    print $error_message;
    return;
  }

  if ( isset($_POST['email']) ) {
    $email = trim($_POST['email']);
  }
  else {
    print $error_message;
    return;
  }

  if ( isset($_POST['unity_id']) ) {
    $unity_id = trim($_POST['unity_id']);
  }
  else {
    print $error_message;
    return;
  }

  if ( isset($_POST['departmentnumber']) ) {
    $departmentnumber = trim($_POST['departmentnumber']);
  }
  else {
    print $error_message;
    return;
  }

  if ( isset($_POST['ncsupreferreddepartment']) ) {
    $ncsupreferreddepartment = trim($_POST['ncsupreferreddepartment']);
  }
  else {
    print $error_message;
    return;
  }

  if ( isset($_POST['ncsuaffiliation']) ) {
    $ncsuaffiliation = trim($_POST['ncsuaffiliation']);
  }
  else {
    print $error_message;
    return;
  }

  if ( isset($_POST['employeetype']) ) {
    $employeetype = trim($_POST['employeetype']);
  }
  else {
    print $error_message;
    return;
  }

  if ( isset($_POST['employeetitle']) ) {
    $employeetitle = trim($_POST['employeetitle']);
  }
  else {
    print $error_message;
    return;
  }

  if ( isset($_POST['ncsuprimaryrole']) ) {
    $ncsuprimaryrole = trim($_POST['ncsuprimaryrole']);
  }
  else {
    print $error_message;
    return;
  }

  // -------------------------------------------------------------------
  // Check to see if there's a matching record in the "users" table.
  $matching_user_result_set = select_matching_user($unity_id);

  // If there is no matching record, insert a new record.
  if ( mysql_num_rows($matching_user_result_set) == 0 ) {
    $user_insert_result = insert_user($name, $email, $unity_id, $departmentnumber, $ncsupreferreddepartment, $ncsuaffiliation, $employeetype, $employeetitle, $ncsuprimaryrole);
    if ($user_insert_result === true) {
      print "<img src=\"images/check.gif\" /> Welcome! You've been added to our records.";
    }
    else {
      print "<img src=\"images/x.gif\" /> " . $userdata_insertion_error;
    }
  }

  // Otherwise, update the record.
  else {
    $user_update_result = update_user($name, $email, $unity_id, $departmentnumber, $ncsupreferreddepartment, $ncsuaffiliation, $employeetype, $employeetitle, $ncsuprimaryrole);
    if ($user_update_result === true) {
      print "<img src=\"images/check.gif\" /> Information updated!";
    }
    else {
      print "<img src=\"images/x.gif\" /> " . $userdata_update_error;
    }
  }

  // db_close($collectionsreview_connection);

?>
